from dataclasses import dataclass
from lkb.lkb_base_class import Concept

from lkb.basic_lkb import Basic_Lexical_Knowledge_Base
from typing import Optional
from file_utils import cached_path

@dataclass(frozen=True)
class TRENDNet_Concept(Concept):
    concept_name: str
    semantic_type: str
    definition: Optional[str] = "NO DEFINITION"

TRENDNet_DATA_PATH = cached_path("https://databrickstrenddata/lkb/trendnet.json")
      
def LKB_factory(lkb_name,lkb_type=Basic_Lexical_Knowledge_Base):
    if lkb_name == 'TRENDNet':
        return lkb_type.read_json(TRENDNet_DATA_PATH,concept_factory=lambda dict: TRENDNet_Concept(**dict))
    